import { memo as _$memo } from "@alloy-js/core/jsx-runtime";
import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { useTransformNamePolicy } from "@typespec/emitter-framework";
import { getDefaultValue } from "../../utils/parameters.js";
export function ParametrizedEndpoint(props) {
  const propNamer = useTransformNamePolicy();
  const paramsRef = ay.refkey();
  const params = _$createComponent(ts.VarDeclaration, {
    name: "params",
    type: "Record<string, any>",
    refkey: paramsRef,
    get children() {
      return _$createComponent(ts.ObjectExpression, {
        get children() {
          return _$createComponent(ay.For, {
            get each() {
              return props.params;
            },
            joiner: ",",
            line: true,
            children: p => {
              const applicationName = propNamer.getApplicationName(p);
              const transportName = propNamer.getTransportName(p);
              const defaultValue = p.defaultValue ? ` ?? ${getDefaultValue(p)}` : "";
              const itemRef = p.optional ? `options?.${applicationName}${defaultValue}` : applicationName;
              return _$createComponent(ts.ObjectProperty, {
                name: transportName,
                value: itemRef
              });
            }
          });
        }
      });
    }
  });
  const resolvedEndpoint = _$createComponent(ts.VarDeclaration, {
    name: "resolvedEndpoint",
    get refkey() {
      return props.refkey;
    },
    get children() {
      return ay.code`
      "${props.template}".replace(/{([^}]+)}/g, (_, key) =>
        key in ${paramsRef} ? String(params[key]) : (() => { throw new Error(\`Missing parameter: $\{key}\`); })()
      );
    `;
    }
  });
  return _$createComponent(ay.StatementList, {
    get children() {
      return [params, resolvedEndpoint];
    }
  });
}
//# sourceMappingURL=parametrized-endpoint.js.map