import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import { memo as _$memo } from "@alloy-js/core/jsx-runtime";
import { For, refkey } from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { $ } from "@typespec/compiler/experimental/typekit";
import * as ef from "@typespec/emitter-framework/typescript";
import { useClientLibrary } from "@typespec/http-client";
import { getFileTypeReference } from "./static-helpers/multipart-helpers.js";
export function Models(props) {
  const clientLibrary = useClientLibrary();
  const dataTypes = clientLibrary.dataTypes;
  return _$createComponent(ts.SourceFile, {
    get path() {
      return props.path ?? "models.ts";
    },
    get children() {
      return _$createComponent(For, {
        each: dataTypes,
        joiner: "\n",
        hardline: true,
        children: type => {
          if ($.model.is(type) && $.model.isHttpFile(type)) {
            return _$createComponent(ts.TypeDeclaration, {
              name: "File",
              "export": true,
              kind: "type",
              get refkey() {
                return refkey(type);
              },
              get children() {
                return getFileTypeReference();
              }
            });
          }
          return $.array.is(type) || $.record.is(type) ? null : _$createComponent(ef.TypeDeclaration, {
            "export": true,
            type: type
          });
        }
      });
    }
  });
}
//# sourceMappingURL=models.js.map