import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { TransformNamePolicyContext } from "@typespec/emitter-framework";
import { ClientLibrary } from "@typespec/http-client/components";
import { EncodingProvider } from "./encoding-provider.js";
import { httpRuntimeTemplateLib } from "./external-packages/ts-http-runtime.js";
import { uriTemplateLib } from "./external-packages/uri-template.js";
import { createTransformNamePolicy } from "./transforms/transform-name-policy.js";
export function Output(props) {
  const tsNamePolicy = ts.createTSNamePolicy();
  const defaultTransformNamePolicy = createTransformNamePolicy();
  return _$createComponent(ay.Output, {
    namePolicy: tsNamePolicy,
    externals: [uriTemplateLib, httpRuntimeTemplateLib],
    get children() {
      return _$createComponent(ClientLibrary, {
        get children() {
          return _$createComponent(TransformNamePolicyContext.Provider, {
            value: defaultTransformNamePolicy,
            get children() {
              return _$createComponent(EncodingProvider, {
                get children() {
                  return props.children;
                }
              });
            }
          });
        }
      });
    }
  });
}
//# sourceMappingURL=output.js.map