import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import { $ } from "@typespec/compiler/experimental/typekit";
import { useTransformNamePolicy } from "@typespec/emitter-framework";
import { reportDiagnostic } from "../../../lib.js";
import { HttpPartTransform } from "./part-transform.js";
export function MultipartTransform(props) {
  const transportNamer = useTransformNamePolicy();
  const httpParts = props.body.parts;
  if (httpParts.length === 0) {
    reportDiagnostic($.program, {
      code: "missing-http-parts",
      target: props.body.property
    });
    return ["[]"];
  }
  const itemRef = transportNamer.getApplicationName(props.body.property);
  const partTransform = _$createComponent(ay.For, {
    each: httpParts,
    comma: true,
    line: true,
    children: part => _$createComponent(HttpPartTransform, {
      part: part,
      itemRef: itemRef
    })
  });
  return ["[", partTransform, "]"];
}
//# sourceMappingURL=multipart-transform.js.map